#pragma once
#include <vfw.h>
#include <mmreg.h>
#include <msacm.h>
#include "DSQuickLib.h"

//#define	AVIPCMSOUNDSTREAM_NUM_BLOCKS	STREAMSOUND_NUM_BLOCKS
#define	MP3SOUNDSTREAM_NUM_BLOCKS	2

#define	MP3SOUNDSTREAM_NUM_HISTORY	16

typedef	struct _playhistory{
	LONG	lFilePos;
	LONG	lPcmPos;
}	MP3PLAYHISTORY;

class CMP3StreamSound : public CSoundObject
{
public:
	CMP3StreamSound(CDSoundEnv *pEnv, TCHAR *pFilename);
	virtual ~CMP3StreamSound(void);
	virtual void DoThread();
	void	PollStatus(FLOAT timeElapsed);
	HRESULT	Prepare();

	virtual HRESULT Play( DWORD dwPriority = 0, DWORD dwFlags = 0, LONG lVol = 0, LONG lFreq = -1, LONG lPan = 0 , LONG lFade = 0);
    virtual HRESULT Stop();
	virtual HRESULT Rewind();
	virtual void	FadeOut(LONG lFadeLen);
	HRESULT	Pause();
	virtual BOOL	IsPlaying();
protected:
	HRESULT		Create();
	HRESULT		FillBufferWithSound( LPDIRECTSOUNDBUFFER pDSB);
	HRESULT		SetNotify();
	HRESULT		MP3StreamReadAndDecode(void *buffer, LONG lSize);
	HRESULT		CheckMP3Format();
	HRESULT		CheckMP3Header(LPBYTE pID);
	CDSoundEnv	*m_pDSoundEnv;
    DWORD       m_dwDSBufferSize;

	//	Datas about the file
	TCHAR	*m_pFilename;
	HMMIO	m_hMMIO;
	LONG	m_lStreamStartOffset;
	LONG	m_lFileSize;
	LONG	m_lFilePos;
	BOOL	m_bSourceStreamActive;
	LONG	m_lPCMSizeDetected;

	MPEGLAYER3WAVEFORMAT	m_wfMP3;
	INT		m_iFrameSize;
	BYTE	*m_pMP3Frame;	//	Pt[̂loRf[^
	INT		m_iSourceBufferSize;

	HACMSTREAM	m_hAcmStream;
	BOOL		m_bAcmHeaderPrepared;	//
	ACMSTREAMHEADER m_acmStreamHeader;

	//	Datas about converted audio
	WAVEFORMATEX	m_wfPcm;
	DWORD			m_dwSizeConverted;

	BYTE		*m_pPcmBuffer;			//	PCM Buffer (target to convert)
	BYTE		*m_pPcmBufferCurrent;	//	CurrentPos in m_pPcmBuffer
	LONG		m_dwPcmBufferSizeRemain;	//	Size of PCM Buffer
	DWORD		m_dwPcmBufferSize;

	//	Managing Sound Buffer
	HANDLE      m_hNotificationEvent[MP3SOUNDSTREAM_NUM_BLOCKS];
	HANDLE		m_hTerminator;

	DWORD       m_dwThreadID;
	HANDLE      m_hThread;

	//	Play History (Pause p)
	MP3PLAYHISTORY	m_pHistory[MP3SOUNDSTREAM_NUM_HISTORY];
	LONG		m_lHistoryRead;
	LONG		m_lHistoryWrite;
	LPDIRECTSOUNDBUFFER	m_lpDSBuffer;
	LONG		m_lVol;
	LONG		m_lFreq;
	LONG		m_lPan;
	LONG		m_lCurrentPosition;
	
	BOOL		m_bThreadDone;
	BOOL		m_bThreadActive;

	DWORD		m_dwNumNotification;
    DWORD		m_dwNotifySize;
	DWORD		m_dwBufferLengthInSec;

	DWORD		m_dwLastPlayPos;
    DWORD		m_dwPlayProgress;
    DWORD		m_dwNextWriteOffset;

	DWORD		m_dwPhase;
	DWORD		m_dwPhaseAfterReplay;
	FLOAT		m_fFadeTime;
	FLOAT		m_fFadeLen;
	CRITICAL_SECTION	m_CriticalSection;

	HRESULT		RestoreBuffer( LPDIRECTSOUNDBUFFER pDSB, BOOL* pbWasRestored );

	HRESULT		Reset();
	HRESULT		HandleNotificationEvent();
};
